/**************************		mov.h	************************/
//#ifndef MOV_H
//#define MOV_H

#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <Windows.h>
#include <conio.h>
//#include <termio.h>

typedef enum boolean {F, T} Bool;

typedef struct Data {
	int stime;
	int stemp;
	int ctime;
	int ctemp;
	//
	int i_cmode;
	char *c_cmode;
};

typedef struct State {
	Bool DoorState;
	Bool Time_TempButtonState;
	Bool ModeButtonState;
	Bool _10sec_10CButtonState;
	Bool _30sec_20CButtonState;
	Bool S_CButtonState;
};

//////////////////////////////////////////////////////////////////////
/*
	public function
*/
//
//int getch(void)
//{
//        int ch;
// 
//        struct termios buf;
//        struct termios save;
// 
//        tcgetattr(0, &save);
//        buf = save;
// 
//        buf.c_lflag &= ~(ICANON|ECHO);
//        buf.c_cc[VMIN] = 1;
//        buf.c_cc[VTIME] = 0;
// 
//        tcsetattr(0, TCSAFLUSH, &buf);
// 
//        ch = getchar();
// 
//        tcsetattr(0, TCSAFLUSH, &save);
// 
//        return ch;
//}

/*
	end public function
*/

/////////////////////////////////////////////////////////////////////
/*
	interface
*/
//Input
void DoorSenSorInterface(Bool DoorSensorInput);
void Time_TempInterface(Bool Time_TempInput);
void ModeButtonInterface(Bool ModeButtonInput);
void _10sec_10CButtonInterface(Bool _10sec_10C_increButtonInput);
void _30sec_20CButtonInterface(Bool _30sec_20C_increButtonInput);
void S_CButtonInterface(Bool S_CButtonInput);
//Output
void Time_TempDisplayInterface(Bool TimeDisplayCommand, Bool TempDisplayCommand);
void ModeDisplayInterface(Bool ModeDisplayCommand);
void LighterInterface(Bool BacklightCommand);
void SpeakerInterface(Bool SpeakCommand);
/*
	end interface
*/

//////////////////////////////////////////////////////////////////////
/*
	buttoncontroller
*/
void buttoncontroller (struct State *s);

void _10secIncrease (Bool trigger);
void _30secIncrease (Bool trigger);
void _10CIncrease (Bool trigger);
void _20CIncrease (Bool trigger);

void ManualMode (Bool trigger);
void DduckMode (Bool trigger);
void JukMode (Bool trigger);
void BobMode (Bool trigger);
void Kuk_JjigaeMode (Bool trigger);
void PizzaMode (Bool trigger);
/*
	end buttoncontroller
*/

/////////////////////////////////////////////////////////////////////
/*
	time_tempcontroller
*/
void Time_TempController(struct Data *d, struct State *s);
void TimeDecreasing(Bool trigger);	
void TempIncreasing(Bool trigger);
void Make_Sound(Bool trigger);
void Light(Bool enable, Bool disable);
/*
	end time_tempcontroller
*/

////////////////////////////////////////////////////////////////////
/*
	displaycontroller
*/
void DisplayController(struct Data *d, struct State *s);
void TimePrint(Bool enable, Bool disable);
void TempPrint(Bool enable, Bool disable);
void ModePrint(Bool enable, Bool disable);
/*
	end displaycontroller
*/


//#endif
/**************************		end		mov.h	************************/












/**************************		main.c		************************/
extern int ABLE = 1;	// odd is Time, even is Temp
extern int DOOR = 0;
extern int SC = 0;
extern struct Data d={0, 20, -1, -1, 0, "Manual"};
extern struct State s={F, F, F, F, F, F};

int main() {
	//int i;				// time check for "for loop" paramater
	char userInput;
	char a;
	Bool DoorSensorInput = F;
	Bool Time_TempInput = F;
	Bool ModeButtonInput = F;
	Bool _10sec_10C_increButtonInput = F;
	Bool _30sec_20C_increButtonInput = F;
	Bool S_CButtonInput = F;
	
	
	
	do {
		fflush(stdin);
		userInput = getch();
		
		system("cls");
		
		SC = 0;

		Time_TempInput = F;
		ModeButtonInput = F;
		_10sec_10C_increButtonInput = F;
		_30sec_20C_increButtonInput = F;
		S_CButtonInput = F;
		DoorSensorInput = F;

		//DisplayController(&d,&s);
		switch(userInput){
			case 'a':
				//printf("%d\n\n\n\n\n\n\n", d.stime);
				_10sec_10C_increButtonInput = T;
				_10sec_10CButtonInterface(_10sec_10C_increButtonInput);
				buttoncontroller(&s);
				Time_TempController(&d, &s);
				DisplayController(&d, &s);
				break;
			case 'b':
				_30sec_20C_increButtonInput = T;
				_30sec_20CButtonInterface(_30sec_20C_increButtonInput);
				buttoncontroller(&s);
				Time_TempController(&d, &s);
				DisplayController(&d, &s);
				break;
			case 'c':
				Time_TempInput = T;
				Time_TempInterface(Time_TempInput);
				buttoncontroller(&s);
				Time_TempController(&d, &s);
				DisplayController(&d, &s);
				break;
			case 'd':
				ModeButtonInput = T;
				ModeButtonInterface(ModeButtonInput);
				buttoncontroller(&s);
				Time_TempController(&d, &s);
				DisplayController(&d, &s);
				break;
			case 'e':
				d.ctime = d.stime;
				d.ctemp = 20;
				S_CButtonInput = T;
				S_CButtonInterface(S_CButtonInput);
				buttoncontroller(&s);
					while ( SC != 1 ) {
						Time_TempController(&d, &s);
						DisplayController(&d, &s);
						a = getch();
						if(a=='e'){
							break;
						}
						//system("cls");
					}
				break;
			case 'f':
				DoorSensorInput = T;
				DoorSenSorInterface(DoorSensorInput);
				buttoncontroller(&s);
				Time_TempController(&d, &s);
				DisplayController(&d, &s);
				break;
			case 'x':
				printf("exit program\n");
				break;
			default:
				printf("please collect menu order\n");
				break;
		}
	} while ('x' != userInput);
	

	return 0;
}
/**************************		end		main.c	************************/














/**************************		interface.c		************************/
/*
Input
*/
void DoorSenSorInterface (Bool DoorSensorInput){
	s.DoorState = DoorSensorInput;
}

void Time_TempInterface (Bool Time_TempInput){
	s.Time_TempButtonState = Time_TempInput;
}

void ModeButtonInterface (Bool ModeButtonInput){
	s.ModeButtonState = ModeButtonInput;
}

void _10sec_10CButtonInterface (Bool _10sec_10C_increButtonInput){
	s._10sec_10CButtonState = _10sec_10C_increButtonInput;
}

void _30sec_20CButtonInterface (Bool _30sec_20C_increButtonInput){
	s._30sec_20CButtonState = _30sec_20C_increButtonInput;
}

void S_CButtonInterface (Bool S_CButtonInput){
	s.S_CButtonState = S_CButtonInput;
} 

///////////////////////////////////////////////////////////////////



/*
Output
*/
void Time_TempDisplayInterface(Bool TimeDisplayCommand, Bool TempDisplayCommand) {
	if ( (T == TimeDisplayCommand) && (F == TempDisplayCommand)) {
		if ( d.ctime == -1 ) {
			printf("%d:%d\t", (d.stime)/60, (d.stime)%60);
		}
		else {
			printf("%d:%d\t", (d.ctime)/60, (d.ctime)%60);
		}
	}
	else {
		if ( d.ctemp == -1 ) {
			printf("%dC\t", d.stemp);
		}
		else {
			printf("%dC\t", d.ctemp);
		}
	}
}
void ModeDisplayInterface(Bool ModeDisplayCommand) {

	if (ModeDisplayCommand == T) {
		printf("Mode : ");

		switch (d.i_cmode) {
		case 0:
			printf("Manual\n");
			break;
		case 1:
			printf("Dduck\n");
			break;
		case 2:
			printf("Juk\n");
			break;
		case 3:
			printf("Bob\n");
			break;
		case 4:
			printf("Kuk_Jjigae\n");
			break;
		case 5:
			printf("Pizza\n");
			break;
		default :
			printf("Error, in switch of ModeDisplayInterface.\n");
		}
	}
	printf("\n");
}
void LighterInterface(Bool BacklightCommand) {
	if ( (T == BacklightCommand) ) {
		printf("%c[1;33m",27);
	}
	else {
		printf("%c[0m", 27);
	}
}
void SpeakerInterface (Bool SpeakCommand) {
	int i;

	if (T == SpeakCommand) {
			printf("\a");
			Sleep(1000);
			printf("\a");
			Sleep(1000);
			printf("\a");
			Sleep(1000);
		SC=1;
	}
}
/**************************		end		interface.c		************************/

/**************************		buttoncontroller.c		************************/
void buttoncontroller (struct State *s){

	static int state = 1;			// odd : Time, even : Temp
	static int mode = 0;		// Mode
	Bool trigger = F;

	if(s->Time_TempButtonState == T){
		state++;
		ABLE++; // sum
		s->Time_TempButtonState = F;
	}
	///
	if( ( s->ModeButtonState == T ) && ( (state % 2) != 0 ) ){
				mode++;
				mode %= 6;
				if ( mode == 0 ) {
					d.stime = 0;
				}
				s->ModeButtonState = F;
	}
	///
	if (mode == 0) {
		trigger = T;
		ManualMode(trigger);
		
		if( ( s->_10sec_10CButtonState == T ) && ( (state % 2) != 0 ) ) {
			s->_10sec_10CButtonState = F;
			trigger = T;		
			_10secIncrease(trigger);
		}
		if( ( s->_30sec_20CButtonState == T ) && ( (state % 2) != 0 ) ){
			s->_30sec_20CButtonState = F;
			trigger = T;		
			_30secIncrease(trigger);	
		}
		////
		if( ( s->_10sec_10CButtonState == T ) && ( (state % 2) == 0 ) ) {
			s->_10sec_10CButtonState = F;
			trigger = T;		
			_10CIncrease(trigger);
		}
		if( ( s->_30sec_20CButtonState == T ) && ( (state % 2) == 0 ) ){
			s->_30sec_20CButtonState = F;
			trigger = T;		
			_20CIncrease(trigger);
		}

	}
	else {
			switch(mode){
				case 1: // Dduck Mode
					trigger = T;
					DduckMode(trigger);
					break;
				case 2: // Juk Mode
					trigger = T;
					JukMode(trigger);
					break;
				case 3: // Bob Mode
					trigger = T;
					BobMode(trigger);
					break;
				case 4: // Kuk_Jjigae Mode
					trigger = T;
					Kuk_JjigaeMode(trigger);
					break;
				case 5: // Pizza Mode
					trigger = T;
					PizzaMode(trigger);
					break;
				default :
					printf("Error, in switch of burroncontroller.\n");
					break;
			} // switch
	}
}

void _10secIncrease (Bool trigger) {
	if(T == trigger) {
		d.stime += 10;
		d.stime %= 600;
	}
}
void _30secIncrease (Bool trigger) {
	if(T == trigger) {
		d.stime += 30;
		d.stime %= 600;
	}
}
void _10CIncrease (Bool trigger) {
	if(T == trigger) {
		d.stemp += 10;
		if(d.stemp > 90) {
			d.stemp = (d.stemp % 70);
		}
	}
}
void _20CIncrease (Bool trigger) {		
	if(T == trigger)		
		d.stemp += 20;
		if(d.stemp > 90) {
			d.stemp = (d.stemp % 70);
		}
}

void ManualMode (Bool trigger) {
	if(T == trigger) {			
		d.i_cmode = 0;
		d.c_cmode = "Manual";
	}
}
void DduckMode (Bool trigger) {
	if(T == trigger) {			
		d.stime = 60;
		d.i_cmode = 1;
		d.c_cmode = "Dduck";
	}
}
void JukMode (Bool trigger) {
	if(T == trigger) {			
		d.stime = 90;
		d.i_cmode = 2;
		d.c_cmode = "Juk";
	}
}
void BobMode (Bool trigger) {
	if(T == trigger) {			
		d.stime = 120;
		d.i_cmode = 3;
		d.c_cmode = "Bob";
	}
}
void Kuk_JjigaeMode (Bool trigger) {
	if(T == trigger) {			
		d.stime = 300;
		d.i_cmode = 4;
		d.c_cmode = "Kuk_Jjigae";
	}
}
void PizzaMode (Bool trigger) {
	if(T == trigger) {			
		d.stime = 120;
		d.i_cmode = 5;
		d.c_cmode = "Pizza";
	}
}
/**************************		end		buttoncontroller.c		************************/

/**************************		time_tempcontroller.c		************************/
void Time_TempController(struct Data *d, struct State *s){

	Bool trigger = F;
	Bool enable = F;
	Bool disable = F;

	if ( s->DoorState == T ) {
		s->DoorState = F;
		DOOR++;
		if ( (DOOR % 2) != 0 ) {
			enable = T;
		}
		else {
			disable = T;
		}
		Light(enable, disable);
	}
	else {
	
		if ( s->S_CButtonState == T ) {
			if( (ABLE % 2) != 0 ){ 			// When ModeState is Time.
				if (d->ctime == 0 ) {
					trigger = T;
					Make_Sound(trigger);
				}
				else {
					trigger = T;
					TimeDecreasing(trigger);
				}
			}
			else if( (ABLE % 2) == 0 ){				// When ModeState is Temp.
				if (d->ctemp >= d->stemp ) {
					trigger = T;
					Make_Sound(trigger);
				}
				else {
					trigger = T;
					TempIncreasing(trigger);
				}
			}
		} // if
	} // else
}

void TimeDecreasing (Bool trigger){
	Sleep(1000);
	d.ctime = d.ctime - 1;
}

void TempIncreasing (Bool trigger){
	Sleep(3000);
	d.ctemp = d.ctemp + 10;
}

void Make_Sound (Bool trigger){
	Bool SpeakCommand = F;	
	if (T == trigger) {
		SpeakCommand = T;	
		SpeakerInterface(SpeakCommand);
	}
	else {
		SpeakCommand = F;
		SpeakerInterface(SpeakCommand);
	}
}
void Light(Bool enable, Bool disable) {
	Bool BacklightCommand = F;
	if ( (T == enable) && (F == disable) ) {
		BacklightCommand = T;
		LighterInterface(BacklightCommand);
	}
	else {
		LighterInterface(BacklightCommand);
	}
}
/**************************		end		time_tempcontroller.c		************************/

/**************************		displaycontroller.c		************************/
void DisplayController(struct Data *d, struct State *s) {
	Bool enable = F;
	Bool disable = F;

	if ( (ABLE % 2) != 0 ) {
		enable = T;
		TimePrint(enable, disable);
		ModePrint(enable, disable);
	}
	else {
		enable = T;
		TempPrint(enable, disable);
		ModePrint(enable, disable);
	}
}


void TimePrint(Bool enable, Bool disable) {
	Bool TimeDisplayCommand = F;
	Bool TempDisplayCommand = F;

	if ( (enable == T) && (disable == F) ) {
		TimeDisplayCommand = T;
		Time_TempDisplayInterface(TimeDisplayCommand, TempDisplayCommand);
	}
}
void TempPrint(Bool enable, Bool disable) {
	Bool TimeDisplayCommand = F;
	Bool TempDisplayCommand = F;

	if ( (enable == T) && (disable == F) ) {
		TempDisplayCommand = T;
		Time_TempDisplayInterface(TimeDisplayCommand, TempDisplayCommand);
	}
}
void ModePrint(Bool enable, Bool disable) {
	Bool ModeDisplayCommand = F;
	
	if ( (enable == T) && (disable == F) ) {
		ModeDisplayCommand = T;
		ModeDisplayInterface(ModeDisplayCommand);
	}
}

/**************************		end		displaycontroller.c		************************/
