#include "CUnit/Automated.h"
#include "CUnit/Basic.h"

//#include "main.h" // 
#include "T3_main_for_gcc.h"

// unit test case

// KDH
void MOW_UTC_00_000() {
	s.Time_TempButtonState = T;
	ABLE = 1;
	
	buttoncontroller (&s);

	CU_ASSERT_EQUAL(d.stime, 0);
}
void MOW_UTC_00_001() {
	s.Time_TempButtonState = T;
	ABLE = 2;

	buttoncontroller (&s);

	CU_ASSERT_EQUAL(d.stemp, 20);
}
void MOW_UTC_00_002() {
	s.ModeButtonState  = T;
	ABLE = 1;
	d.i_cmode = 5;

	buttoncontroller (&s);

	CU_ASSERT_EQUAL(d.stime, 0);
}
void MOW_UTC_00_003() {
	s._10sec_10CButtonState = T;
	ABLE = 1;

	buttoncontroller (&s);

	CU_ASSERT_EQUAL(trigger, T);
}
void MOW_UTC_00_004() {
	s._10sec_10CButtonState = T;
	ABLE = 2;

	buttoncontroller (&s);

	CU_ASSERT_EQUAL(trigger, T);
}
void MOW_UTC_00_005() {
	s._30sec_20CButtonState = T;
	ABLE = 1;

	buttoncontroller (&s);

	CU_ASSERT_EQUAL(trigger, T);
}
void MOW_UTC_00_006() {
	s._30sec_20CButtonState = T;
	ABLE = 2;

	buttoncontroller (&s);

	CU_ASSERT_EQUAL(trigger, T);
}
///////////////////////////////////////

// HDH
void MOW_UTC_01_000() {
	s.DoorState = T;
	DOOR = 1;

	Time_TempController(&d, &s);

	CU_ASSERT_EQUAL(enable, T);
}
void MOW_UTC_01_001() {
	s.DoorState = T;
	DOOR = 2;

	Time_TempController(&d, &s);

	CU_ASSERT_EQUAL(disable, T);
}
void MOW_UTC_01_002() {
	s.DoorState = F;
	s.S_CButtonState = T;
	ABLE = 1;
	d.ctime = 40;

	Time_TempController(&d, &s);

	CU_ASSERT_EQUAL(d.ctime, 39);
}
void MOW_UTC_01_003() {
	s.DoorState = F;
	s.S_CButtonState = T;
	ABLE = 1;
	d.ctime = 0;

	Time_TempController(&d, &s);

	CU_ASSERT_EQUAL(trigger, T);
}
void MOW_UTC_01_004() {
	s.DoorState = F;
	s.S_CButtonState = T;
	ABLE = 2;
	d.ctemp = 20;
	d.stemp = 50;

	Time_TempController(&d, &s);

	CU_ASSERT_EQUAL(d.ctemp, 30);
}
void MOW_UTC_01_005() {
	s.DoorState = F;
	s.S_CButtonState = T;
	ABLE = 2;
	d.ctemp = 40;
	d.stemp = 40;

	Time_TempController(&d, &s);

	CU_ASSERT_EQUAL(trigger, T);
}
////////////////////////////////////////////

// SMY
void MOW_UTC_02_000(void) { 
	ABLE = 1; 
	
	DisplayController(&d, &s); 
	
	CU_ASSERT_EQUAL(enable, T); 
} 

void MOW_UTC_02_001(void) { 
	ABLE = 2; 
	
	DisplayController(&d, &s); 
	
	CU_ASSERT_EQUAL(enable, T); 
} 
////////////////////////////////////////////

void MOW_UTC_07_000(void) { 
	trigger = T;
	d.stime = 30;
	
	_10secIncrease(T); 
	
	CU_ASSERT_EQUAL(d.stime, 40); 
} 
////////////////////////////////////////////

void MOW_UTC_08_000(void) { 
	trigger = T;
	d.stemp = 40;
	
	_10CIncrease(T); 
	
	CU_ASSERT_EQUAL(d.stemp, 50); 
} 
////////////////////////////////////////////

void MOW_UTC_09_000(void) { 
	trigger = T;
	d.stime = 90;
	
	_30secIncrease(T); 
	
	CU_ASSERT_EQUAL(d.stime, 120); 
} 
////////////////////////////////////////////

void MOW_UTC_10_000(void) { 
	trigger = T;
	d.stemp = 50;
	
	_20CIncrease(T); 
	
	CU_ASSERT_EQUAL(d.stemp, 70); 
} 
////////////////////////////////////////////

void MOW_UTC_13_000(void) { 
	trigger = T;
	d.ctemp = 50;
	
	TempIncreasing(T); 
	
	CU_ASSERT_EQUAL(d.ctemp, 60); 
} 
////////////////////////////////////////////

void MOW_UTC_14_000(void) { 
	trigger = T;
	d.ctime = 80;
	
	TimeDecreasing(T); 
	
	CU_ASSERT_EQUAL(d.ctime, 79); 
} 

// main
int main(void) {
	CU_pSuite pSuite = NULL;

	if ( CUE_SUCCESS != CU_initialize_registry() ) return CU_get_error();

	pSuite = CU_add_suite("testing a suite", NULL, NULL);
	if ( NULL == pSuite ) {
		CU_cleanup_registry();
		return CU_get_error();
	}
	
	// add test case to the suite

	// KDH
	if ( NULL == CU_add_test(pSuite, "MOW_UTC_00_000", MOW_UTC_00_000) ) {
		CU_cleanup_registry();
		return CU_get_error();
	}
	if ( NULL == CU_add_test(pSuite, "MOW_UTC_00_001", MOW_UTC_00_001) ) {
		CU_cleanup_registry();
		return CU_get_error();
	}
	if ( NULL == CU_add_test(pSuite, "MOW_UTC_00_002", MOW_UTC_00_002) ) {
		CU_cleanup_registry();
		return CU_get_error();
	}
	if ( NULL == CU_add_test(pSuite, "MOW_UTC_00_003", MOW_UTC_00_003) ) {
		CU_cleanup_registry();
		return CU_get_error();
	}
	if ( NULL == CU_add_test(pSuite, "MOW_UTC_00_004", MOW_UTC_00_004) ) {
		CU_cleanup_registry();
		return CU_get_error();
	}
	if ( NULL == CU_add_test(pSuite, "MOW_UTC_00_005", MOW_UTC_00_005) ) {
		CU_cleanup_registry();
		return CU_get_error();
	}
	if ( NULL == CU_add_test(pSuite, "MOW_UTC_00_006", MOW_UTC_00_006) ) {
		CU_cleanup_registry();
		return CU_get_error();
	}

	// HDH
	if ( NULL == CU_add_test(pSuite, "MOW_UTC_01_000", MOW_UTC_01_000) ) {
		CU_cleanup_registry();
		return CU_get_error();
	}
	if ( NULL == CU_add_test(pSuite, "MOW_UTC_01_001", MOW_UTC_01_001) ) {
		CU_cleanup_registry();
		return CU_get_error();
	}
	if ( NULL == CU_add_test(pSuite, "MOW_UTC_01_002", MOW_UTC_01_002) ) {
		CU_cleanup_registry();
		return CU_get_error();
	}
	if ( NULL == CU_add_test(pSuite, "MOW_UTC_01_003", MOW_UTC_01_003) ) {
		CU_cleanup_registry();
		return CU_get_error();
	}
	if ( NULL == CU_add_test(pSuite, "MOW_UTC_01_004", MOW_UTC_01_004) ) {
		CU_cleanup_registry();
		return CU_get_error();
	}
	if ( NULL == CU_add_test(pSuite, "MOW_UTC_01_005", MOW_UTC_01_005) ) {
		CU_cleanup_registry();
		return CU_get_error();
	}


	// SMY
	if ( NULL == CU_add_test(pSuite, "MOW_UTC_02_000", MOW_UTC_02_000) ) {
		CU_cleanup_registry();
		return CU_get_error();
	}
	if ( NULL == CU_add_test(pSuite, "MOW_UTC_02_001", MOW_UTC_02_001) ) {
		CU_cleanup_registry();
		return CU_get_error();
	}


	if ( NULL == CU_add_test(pSuite, "MOW_UTC_07_000", MOW_UTC_07_000) ) {
		CU_cleanup_registry();
		return CU_get_error();
	}


	if ( NULL == CU_add_test(pSuite, "MOW_UTC_08_000", MOW_UTC_08_000) ) {
		CU_cleanup_registry();
		return CU_get_error();
	}


	if ( NULL == CU_add_test(pSuite, "MOW_UTC_09_000", MOW_UTC_09_000) ) {
		CU_cleanup_registry();
		return CU_get_error();
	}


	if ( NULL == CU_add_test(pSuite, "MOW_UTC_10_000", MOW_UTC_10_000) ) {
		CU_cleanup_registry();
		return CU_get_error();
	}


	if ( NULL == CU_add_test(pSuite, "MOW_UTC_13_000", MOW_UTC_13_000) ) {
		CU_cleanup_registry();
		return CU_get_error();
	}


	if ( NULL == CU_add_test(pSuite, "MOW_UTC_14_000", MOW_UTC_14_000) ) {
		CU_cleanup_registry();
		return CU_get_error();
	}

	// LGS

	
	// basic run
	CU_basic_set_mode(CU_BRM_VERBOSE);
	CU_basic_run_tests();

	CU_cleanup_registry();

	return CU_get_error();
}
